openapi: 3.0.1 info: title: REST API description: "The Coinbase Prime REST API provides programmatic access to trading,\ \ custody, staking, market data, and account management functionality." version: "0.1" servers: - url: https://api.prime.coinbase.com/ tags: - name: PrimeRESTAPI paths: /v1/activities/{activity_id}: get: tags: - Activities summary: Get Activity by Activity ID description: Retrieve an activity by its activity ID - this endpoint can retrieve both portfolio and entity activities when passed the appropriate API key operationId: PrimeRESTAPI_GetActivity parameters: - name: activity_id in: path description: Id of the activity to retrieve required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetActivityResponse' /v1/allocations: post: tags: - Allocations summary: Create Portfolio Allocations description: Create allocation for a given portfolio. operationId: PrimeRESTAPI_CreateAllocation requestBody: content: application/json: schema: $ref: '#/components/schemas/public_rest_apiCreateAllocationRequest' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateAllocationResponse' x-codegen-request-body-name: body /v1/allocations/net: post: tags: - Allocations summary: Create Portfolio Net Allocations description: Create net allocation for a given portfolio. operationId: PrimeRESTAPI_CreateNetAllocation requestBody: content: application/json: schema: $ref: '#/components/schemas/public_rest_apiCreateNetAllocationRequest' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateNetAllocationResponse' x-codegen-request-body-name: body /v1/entities/{entity_id}/accruals: get: tags: - Financing summary: List Interest Accruals description: Lists interest accruals for an entity between the specified date range given operationId: PrimeRESTAPI_GetInterestAccruals parameters: - name: entity_id in: path description: The unique ID of the entity required: true schema: type: string - name: portfolio_id in: query description: The unique ID of the portfolio schema: type: string - name: start_date in: query description: The start date of the range to query for in RFC3339 format schema: type: string - name: end_date in: query description: The end date of the range to query for in RFC3339 format schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetInterestAccrualsResponse' /v1/entities/{entity_id}/activities: get: tags: - Activities summary: List Entity Activities description: List all activities associated with a given entity. operationId: PrimeRESTAPI_GetEntityActivities parameters: - name: entity_id in: path description: Entity to retrieve activities for required: true schema: type: string - name: activity_level in: query description: Activity level to retrieve activities for schema: type: string default: ACTIVITY_LEVEL_ALL enum: - ACTIVITY_LEVEL_ALL - ACTIVITY_LEVEL_PORTFOLIO - ACTIVITY_LEVEL_ENTITY - name: symbols in: query description: Filter by list of currencies style: form explode: true schema: type: array items: type: string - name: categories in: query description: "Filter by list of activity categories [order, transaction, account,\ \ allocation, lending]" style: form explode: true schema: type: array items: type: string enum: - OTHER_ACTIVITY_CATEGORY - ACTIVITY_CATEGORY_ORDER - ACTIVITY_CATEGORY_TRANSACTION - ACTIVITY_CATEGORY_ACCOUNT - ACTIVITY_CATEGORY_ALLOCATION - ACTIVITY_CATEGORY_LENDING - name: statuses in: query description: Filter by list of statuses style: form explode: true schema: type: array items: type: string enum: - OTHER_ACTIVITY_STATUS - ACTIVITY_STATUS_CANCELLED - ACTIVITY_STATUS_PROCESSING - ACTIVITY_STATUS_COMPLETED - ACTIVITY_STATUS_EXPIRED - ACTIVITY_STATUS_REJECTED - ACTIVITY_STATUS_FAILED - name: start_time in: query description: Filter created time by start date (RFC3339 format) schema: type: string - name: end_time in: query description: Filter created time by end date (RFC3339 format) schema: type: string - name: cursor in: query description: Id to retrieve additional results strictly after schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC - name: get_network_unified_activities in: query description: Flag to request retrieval of all activities across all networks for a given symbol schema: type: boolean responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetEntityActivitiesResponse' /v1/entities/{entity_id}/aggregate_positions: get: tags: - Positions summary: List Aggregate Entity Positions description: List paginated aggregate positions for a specific entity. operationId: PrimeRESTAPI_ListAggregateEntityPositions parameters: - name: entity_id in: path description: The unique ID of the entity required: true schema: type: string - name: cursor in: query description: Id to retrieve additional results strictly after schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListAggregateEntityPositionsResponse' /v1/entities/{entity_id}/assets: get: tags: - Assets summary: List Assets description: List all assets available for a given entity. operationId: PrimeRESTAPI_GetEntityAssets parameters: - name: entity_id in: path description: The entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetEntityAssetsResponse' /v1/entities/{entity_id}/balances: get: tags: - Balances summary: List Entity Balances description: List all balances for a specific entity. operationId: PrimeRESTAPI_ListEntityBalances parameters: - name: entity_id in: path description: The entity ID required: true schema: type: string - name: symbols in: query description: A list of symbols by which to filter the response schema: type: string - name: cursor in: query description: Id to retrieve additional results strictly after schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: aggregation_type in: query description: |- A type by which to filter aggregated balances, defaults to "TOTAL" - UNKNOWN_BALANCE_TYPE: nil - TRADING_BALANCES: Trading balances - VAULT_BALANCES: Vault balances - TOTAL_BALANCES: Total balances (The sum of vault and trading + prime custody) - PRIME_CUSTODY_BALANCES: Prime custody balances - UNIFIED_TOTAL_BALANCES: Unified total balance across networks and wallet types (vault + trading + prime custody) schema: type: string enum: - TRADING_BALANCES - VAULT_BALANCES - TOTAL_BALANCES - PRIME_CUSTODY_BALANCES - UNIFIED_TOTAL_BALANCES responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListEntityBalancesResponse' /v1/entities/{entity_id}/cross_margin: get: tags: - Financing summary: Get Exchange Cross Margin Overview description: Gets live data for Cross Margin (XM) for a specific XM customer operationId: PrimeRESTAPI_GetCrossMarginOverview parameters: - name: entity_id in: path description: XM customer Prime Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetCrossMarginOverviewResponse' /v1/entities/{entity_id}/cross_margin/risk_parameters: get: tags: - Financing summary: Get Cross Margin Risk Parameters description: Gets the current Cross Margin (XM) risk parameters for an entity. operationId: PrimeRESTAPI_GetCrossMarginRiskParameters parameters: - name: entity_id in: path description: XM customer Prime Entity ID. required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetCrossMarginRiskParametersResponse' /v1/entities/{entity_id}/funding_settings: post: tags: - Financing summary: Update Funding Settings description: Sets FCM funding configuration for the entity and submits the desired configuration to Prime API for approval. operationId: PrimeRESTAPI_UpdateFundingSettings parameters: - name: entity_id in: path description: Prime Entity ID required: true schema: type: string requestBody: content: application/json: schema: required: - automatic_conversion_enabled - automatic_excess_return_enabled - automatic_loan_enabled - designated_funding_portfolio_id - excess_funds_target_amount type: object properties: designated_funding_portfolio_id: type: string description: Set the Derivatives Funding Portfolio that will be used to fund FCM margin calls and receive excess margin sweeps. Only one portfolio per entity. example: a0724c0c-0f9e-4525-baf4-1aa8fce77eb2 automatic_conversion_enabled: type: boolean description: "When true, USDC in your Derivatives Funding Portfolio\ \ will be converted to USD to meet FCM margin calls (Auto-Convert\ \ USDC)." automatic_loan_enabled: type: boolean description: "When true, Coinbase affiliates may initiate loans\ \ on your behalf to meet FCM margin calls, per your Lending agreement.\ \ Available to Portfolio Margin or Cross Margin clients only.\ \ (Auto-Initiate Loans)" automatic_excess_return_enabled: type: boolean description: "When true, any FCM account balance above your margin\ \ requirements will be automatically swept back to your Derivatives\ \ funding portfolio. (Auto-Return Excess Margin)" excess_funds_target_amount: type: string description: "Weekend Buying Power: Setting a target amount to maintain\ \ in your Futures account above margin requirements. You can only\ \ withdraw funds in excess of this amount." example: "1000.00" required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.UpdateFundingSettingsResponse' x-codegen-request-body-name: body /v1/entities/{entity_id}/futures/auto_sweep: post: tags: - Futures summary: Set Auto Sweep description: Set auto sweep for a given entity. operationId: PrimeRESTAPI_SetAutoSweep parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string requestBody: content: application/json: schema: required: - auto_sweep type: object properties: auto_sweep: type: boolean description: "Auto sweep status, default to false" example: true required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.SetAutoSweepResponse' x-codegen-request-body-name: body /v1/entities/{entity_id}/futures/balance_summary: get: tags: - Futures summary: Get Entity FCM Balance description: Retrieve fcm balance for a given entity. operationId: PrimeRESTAPI_GetFcmBalance parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetFcmBalanceResponse' /v1/entities/{entity_id}/futures/equity: get: tags: - Futures summary: Get FCM Equity description: Retrieve the equity data for a given entity. operationId: PrimeRESTAPI_GetFcmEquity parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetFcmEquityResponse' /v1/entities/{entity_id}/futures/margin_call_details: get: tags: - Futures summary: Get FCM Margin Call Details description: Retrieve the margin call details for a given entity. operationId: PrimeRESTAPI_GetFcmMarginCallDetails parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetFcmMarginCallDetailsResponse' /v1/entities/{entity_id}/futures/positions: get: tags: - Futures summary: Get Entity Positions description: Retrieve all active fcm positions for a given entity. operationId: PrimeRESTAPI_GetPositions parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string - name: product_id in: query description: Product ID. Optional schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPositionsResponse' /v1/entities/{entity_id}/futures/risk_limits: get: tags: - Futures summary: Get FCM Risk Limits description: Retrieve the risk limits for a given entity. operationId: PrimeRESTAPI_GetFcmRiskLimits parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetFcmRiskLimitsResponse' /v1/entities/{entity_id}/futures/settings: get: tags: - Futures summary: Get FCM Settings description: Get settings related to FCM. operationId: PrimeRESTAPI_GetFcmSettings parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetFcmSettingsResponse' post: tags: - Futures summary: Set FCM Settings description: Update settings related to FCM. operationId: PrimeRESTAPI_SetFcmSettings parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string requestBody: content: application/json: schema: type: object properties: target_derivatives_excess: type: string description: Target CFM Excess amount to set. Only non-negative number is allowed example: "1000.00" required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.SetFcmSettingsResponse' x-codegen-request-body-name: body /v1/entities/{entity_id}/futures/sweeps: get: tags: - Futures summary: List Entity Futures Sweeps description: "Retrieve fcm sweeps in open status, including pending and processing\ \ sweeps." operationId: PrimeRESTAPI_GetFuturesSweeps parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetFuturesSweepsResponse' post: tags: - Futures summary: Schedule Entity Futures Sweep description: Schedule a sweep for a given entity from FCM wallet to USD Spot wallet. Only one pending sweep is allowed at a time per entity. operationId: PrimeRESTAPI_ScheduleFuturesSweep parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string requestBody: content: application/json: schema: required: - currency type: object properties: amount: type: string description: Amount. Default to sweep all if not provided example: "1000.00" currency: type: string description: Currency. Required example: USD required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ScheduleFuturesSweepResponse' x-codegen-request-body-name: body delete: tags: - Futures summary: Cancel Entity Futures Sweep description: "Cancel the pending sweep for a given entity. A user will only\ \ be able to have one pending sweep at a time. If the sweep is not found,\ \ a 404 will be returned." operationId: PrimeRESTAPI_CancelFuturesSweep parameters: - name: entity_id in: path description: Entity ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CancelFuturesSweepResponse' /v1/entities/{entity_id}/invoices: get: tags: - Invoice summary: List Invoices description: Retrieve a list of invoices belonging to an entity. operationId: PrimeRESTAPI_GetInvoices parameters: - name: entity_id in: path description: The entity ID required: true schema: type: string - name: states in: query description: Invoice states to filter the response style: form explode: true schema: type: array items: type: string enum: - INVOICE_STATE_UNSPECIFIED - INVOICE_STATE_IMPORTED - INVOICE_STATE_BILLED - INVOICE_STATE_PARTIALLY_PAID - INVOICE_STATE_PAID - name: billing_year in: query description: Filter invoices by year schema: type: integer format: int32 - name: billing_month in: query description: "Integer representing the month to filter by, 1 for January,\ \ 12 for December" schema: type: integer format: int32 - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: integer format: int32 - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetInvoicesResponse' /v1/entities/{entity_id}/locates_availability: get: tags: - Financing summary: Get Entity Locate Availabilities description: Get currencies available to be located with their corresponding amount and rate. operationId: PrimeRESTAPI_GetLocateAvailabilities parameters: - name: entity_id in: path description: The unique ID of the entity required: true schema: type: string - name: conversion_date in: query description: "Deprecated: Use locate_date instead" schema: type: string - name: locate_date in: query description: The date of the locate availability in YYYY-MM-DD format schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetLocateAvailabilitiesResponse' /v1/entities/{entity_id}/margin: get: tags: - Financing summary: Get Margin Information description: Gets real-time evaluation of the margin model based on current positions and spot rates. operationId: PrimeRESTAPI_GetMarginInformation parameters: - name: entity_id in: path description: The unique ID of the entity required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetMarginInformationResponse' /v1/entities/{entity_id}/margin_summaries: get: tags: - Financing summary: List Margin Call Summaries description: Lists the margin call history for a given entity ID. operationId: PrimeRESTAPI_GetMarginSummaries parameters: - name: entity_id in: path description: The unique ID of the entity required: true schema: type: string - name: start_date in: query description: The start date of the range to query for in RFC3339 format. Must be within the last 3 months schema: type: string - name: end_date in: query description: The end date of the range to query for in RFC3339 format schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetMarginSummariesResponse' /v1/entities/{entity_id}/market_data: get: tags: - Financing summary: Get Market Data description: Retrieves market data including volatility and average daily volume for an entity. operationId: PrimeRESTAPI_GetMarketData parameters: - name: entity_id in: path description: Prime Entity ID required: true schema: type: string - name: cursor in: query description: Cursor for pagination schema: type: string - name: limit in: query description: Number of results to return per page schema: type: integer format: int32 - name: sort_direction in: query description: Sort direction for results schema: type: string default: DESC enum: - DESC - ASC responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetMarketDataResponse' /v1/entities/{entity_id}/payment-methods: get: tags: - Payment Methods summary: List Entity Payment Methods description: Retrieve all payment methods for a given entity. operationId: PrimeRESTAPI_GetEntityPaymentMethods parameters: - name: entity_id in: path required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetEntityPaymentMethodsResponse' /v1/entities/{entity_id}/payment-methods/{payment_method_id}: get: tags: - Payment Methods summary: Get Entity Payment Method description: Get payment method details by id for a given entity. operationId: PrimeRESTAPI_GetEntityPaymentMethodDetails parameters: - name: entity_id in: path required: true schema: type: string - name: payment_method_id in: path required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetEntityPaymentMethodDetailsResponse' /v1/entities/{entity_id}/positions: get: tags: - Positions summary: List Entity Positions description: List paginated positions for a specific entity. operationId: PrimeRESTAPI_ListEntityPositions parameters: - name: entity_id in: path description: The unique ID of the entity required: true schema: type: string - name: cursor in: query description: Id to retrieve additional results strictly after schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListEntityPositionsResponse' /v1/entities/{entity_id}/tf_obligations: get: tags: - Financing summary: List Trade Finance Obligations description: List trade finance obligations for a given entity. operationId: PrimeRESTAPI_ListTFObligations parameters: - name: entity_id in: path description: The entity ID to retrieve obligations for required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListTFObligationsResponse' /v1/entities/{entity_id}/tf_tiered_fees: get: tags: - Financing summary: Get Trade Finance Tiered Pricing Fees description: "Get trade finance tiered pricing fees for a given entity at a\ \ specific time, default to current time." operationId: PrimeRESTAPI_GetTFTieredPricingFees parameters: - name: entity_id in: path description: The unique ID of the entity required: true schema: type: string - name: effective_at in: query description: The fees on a specific effective date in RFC3339 format schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetTFTieredPricingFeesResponse' /v1/entities/{entity_id}/users: get: tags: - Users summary: List Users description: List all users associated with a given entity. operationId: PrimeRESTAPI_GetEntityUsers parameters: - name: entity_id in: path description: The entity ID required: true schema: type: string - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetEntityUsersResponse' /v1/financing/eligible-assets: get: tags: - Financing summary: List Financing Eligible Assets description: Get all assets eligible for Trade Finance with their adjustment factors. operationId: PrimeRESTAPI_ListFinancingEligibleAssets responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListFinancingEligibleAssetsResponse' /v1/portfolios: get: tags: - Portfolios summary: List Portfolios description: List all portfolios for which the current API key has read access. operationId: PrimeRESTAPI_GetPortfolios responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfoliosResponse' /v1/portfolios/{portfolio_id}: get: tags: - Portfolios summary: Get Portfolio by Portfolio ID description: Retrieve a given portfolio by its portfolio ID. operationId: PrimeRESTAPI_GetPortfolio parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioResponse' /v1/portfolios/{portfolio_id}/accept_quote: post: tags: - Orders summary: Accept Quote description: |- Accepts the quote received by the quote request and creates an order with the provided quote ID. Always required: portfolio_id, product_id, side, quote_id, client_quote_id. operationId: PrimeRESTAPI_AcceptQuote parameters: - name: portfolio_id in: path description: The ID of the portfolio that owns the order required: true schema: type: string requestBody: content: application/json: schema: required: - client_order_id - product_id - quote_id - side type: object properties: product_id: title: The ID of the product being traded for the order (e.g. `BTC-USD`) type: string side: $ref: '#/components/schemas/coinbase.public_rest_api.OrderSide' client_order_id: type: string description: "A client-generated ID used for reference purposes\ \ (note: order will be rejected if this ID is not unique among\ \ all currently active orders)" example: f69a20b1-4ac4-420e-90b5-814a12565bfa quote_id: type: string description: A quote id that was returned from the quote request example: f69a20b1-4ac4-420e-90b5-814a12565bfa settl_currency: title: "next: 7" type: string required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.AcceptQuoteResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/accruals: get: tags: - Financing summary: List Interest Accruals For Portfolio description: Lists interest accruals between the specified date range for a specific portfolio ID operationId: PrimeRESTAPI_GetPortfolioInterestAccruals parameters: - name: portfolio_id in: path description: The unique ID of the portfolio required: true schema: type: string - name: start_date in: query description: The start date of the range to query for in RFC3339 format schema: type: string - name: end_date in: query description: The end date of the range to query for in RFC3339 format schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioInterestAccrualsResponse' /v1/portfolios/{portfolio_id}/activities: get: tags: - Activities summary: List Activities description: List all activities associated with a given portfolio. operationId: PrimeRESTAPI_GetPortfolioActivities parameters: - name: portfolio_id in: path description: Portfolio to retrieve activities for. required: true schema: type: string - name: symbols in: query description: Filter by list of currencies style: form explode: true schema: type: array items: type: string - name: categories in: query description: "Filter by list of activity categories [order, transaction, account,\ \ allocation, lending]" style: form explode: true schema: type: array items: type: string enum: - OTHER_ACTIVITY_CATEGORY - ACTIVITY_CATEGORY_ORDER - ACTIVITY_CATEGORY_TRANSACTION - ACTIVITY_CATEGORY_ACCOUNT - ACTIVITY_CATEGORY_ALLOCATION - ACTIVITY_CATEGORY_LENDING - name: statuses in: query description: Filter by list of statuses style: form explode: true schema: type: array items: type: string enum: - OTHER_ACTIVITY_STATUS - ACTIVITY_STATUS_CANCELLED - ACTIVITY_STATUS_PROCESSING - ACTIVITY_STATUS_COMPLETED - ACTIVITY_STATUS_EXPIRED - ACTIVITY_STATUS_REJECTED - ACTIVITY_STATUS_FAILED - name: start_time in: query description: Filter created time by start date (RFC3339 format) schema: type: string - name: end_time in: query description: Filter created time by end date (RFC3339 format) schema: type: string - name: cursor in: query description: Id to retrieve additional results strictly after schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC - name: get_network_unified_activities in: query description: Flag to request retrieval of all activities across all networks for a given symbol schema: type: boolean responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioActivitiesResponse' /v1/portfolios/{portfolio_id}/activities/{activity_id}: get: tags: - Activities summary: Get Portfolio Activity by Activity ID description: Retrieve an activity by its activity ID operationId: PrimeRESTAPI_GetPortfolioActivity parameters: - name: portfolio_id in: path description: Portfolio to retrieve activity for. required: true schema: type: string - name: activity_id in: path description: Id of the activity to retrieve required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioActivityResponse' /v1/portfolios/{portfolio_id}/address_book: get: tags: - Address Book summary: Get Address Book description: Gets a list of address book addresses. operationId: PrimeRESTAPI_GetPortfolioAddressBook parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string - name: currency_symbol in: query description: "Cryptocurrency symbol -- if nothing is passed, all addresses\ \ are returned" schema: type: string - name: search in: query description: Query string that matches the address name schema: type: string - name: cursor in: query description: ID marking the point after which additional results should be retrieved schema: type: string - name: limit in: query description: Number of addresses to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioAddressBookResponse' post: tags: - Address Book summary: Create Address Book Entry description: Creates an entry for a portfolio's trusted addresses. operationId: PrimeRESTAPI_CreatePortfolioAddressBookEntry parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string requestBody: content: application/json: schema: required: - address - currency_symbol - name type: object properties: address: type: string description: Crypto address to add currency_symbol: type: string description: Currency symbol of address to add name: type: string description: Name of address book entry account_identifier: type: string description: Account Identifier (memo/destination tag) chain_ids: type: array description: "List of compatible chain IDs for the address, empty\ \ for Solana" items: type: string required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreatePortfolioAddressBookEntryResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/advanced_transfers: get: tags: - Advanced Transfer summary: List Advanced Transfers description: List advanced transfers for a given portfolio. This API is currently not available to all clients. Please reach out to Prime Operations with any questions. operationId: PrimeRESTAPI_ListAdvancedTransfers parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: state in: query description: The state of the Advanced Transfer to filter by schema: type: string enum: - ADVANCED_TRANSFER_STATE_CREATED - ADVANCED_TRANSFER_STATE_PROCESSING - ADVANCED_TRANSFER_STATE_DONE - ADVANCED_TRANSFER_STATE_CANCELLED - ADVANCED_TRANSFER_STATE_FAILED - ADVANCED_TRANSFER_STATE_EXPIRED - name: type in: query description: The type of the Advanced Transfer to filter by schema: type: string enum: - ADVANCED_TRANSFER_TYPE_BLIND_MATCH - name: cursor in: query description: The cursor to use for pagination schema: type: string - name: limit in: query description: The maximum number of Advanced Transfers to return schema: type: integer format: int32 - name: sort_direction in: query description: Page sorting direction schema: type: string default: DESC enum: - DESC - ASC - name: start_time in: query description: "UTC timestamp of creation from which to filter the response\ \ (inclusive, ISO-8601 format)" schema: type: string format: date-time - name: end_time in: query description: "UTC timestamp of creation until which to filter the response\ \ (exclusive, ISO-8601 format)" schema: type: string format: date-time - name: reference_id in: query description: The reference ID of the Advanced Transfer to filter by schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListAdvancedTransfersResponse' post: tags: - Advanced Transfer summary: Create Advanced Transfer description: Create advanced transfer for a given portfolio. This API is currently not available to all clients. Please reach out to Prime Operations with any questions. operationId: PrimeRESTAPI_CreateAdvancedTransfer parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string requestBody: content: application/json: schema: required: - advanced_transfer type: object properties: advanced_transfer: $ref: '#/components/schemas/coinbase.public_rest_api.AdvancedTransfer' description: CreateAdvancedTransferRequest is the request to create an advanced transfer. required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateAdvancedTransferResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/advanced_transfers/{advanced_transfer_id}/cancel: post: tags: - Advanced Transfer summary: Cancel Advanced Transfer description: Cancel advanced transfer for a given portfolio. This API is currently not available to all clients. Please reach out to Prime Operations with any questions. operationId: PrimeRESTAPI_CancelAdvancedTransfer parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: advanced_transfer_id in: path description: The ID of the canceled Advanced Transfer required: true schema: type: string requestBody: content: application/json: schema: type: object description: CancelAdvancedTransferRequest is the request to cancel an advanced transfer. required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CancelAdvancedTransferResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/advanced_transfers/{advanced_transfer_id}/transactions: get: tags: - Transactions summary: List transactions associated with an Advanced Transfer description: List transactions associated with an Advanced Transfer. This API is currently not available to all clients. Please reach out to Prime Operations with any questions. operationId: PrimeRESTAPI_ListAdvancedTransferTransactions parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: advanced_transfer_id in: path description: The ID of the Advanced Transfer required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListAdvancedTransferTransactionsResponse' /v1/portfolios/{portfolio_id}/allocations: get: tags: - Allocations summary: List Portfolio Allocations description: List historical allocations for a given portfolio. operationId: PrimeRESTAPI_GetPortfolioAllocations parameters: - name: portfolio_id in: path description: Portfolio to retrieve allocations for. required: true schema: type: string - name: product_ids in: query description: List of products by which to filter the response. style: form explode: true schema: type: array items: type: string - name: order_side in: query description: |- An order side to filter allocations on. - UNKNOWN_ORDER_SIDE: nil value - BUY: Buy order - SELL: Sell order schema: type: string enum: - BUY - SELL - name: start_date in: query description: A start date for the allocations to be queried from. required: true schema: type: string format: date-time - name: end_date in: query description: An end date for the orders to be queried from. schema: type: string format: date-time - name: cursor in: query description: Id to retrieve additional results strictly after schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: "Sorting order: DESC or ASC" schema: type: string default: DESC enum: - DESC - ASC responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioAllocationsResponse' /v1/portfolios/{portfolio_id}/allocations/net/{netting_id}: get: tags: - Allocations summary: Get Net Allocations by Netting ID description: Retrieve an allocation by netting ID. operationId: PrimeRESTAPI_GetAllocationsByClientNettingId parameters: - name: portfolio_id in: path description: The portfolio ID of the allocation required: true schema: type: string - name: netting_id in: path description: The allocation netting ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetAllocationsByClientNettingIdResponse' /v1/portfolios/{portfolio_id}/allocations/{allocation_id}: get: tags: - Allocations summary: Get Allocation by ID description: Retrieve an allocation by allocation ID. operationId: PrimeRESTAPI_GetAllocation parameters: - name: portfolio_id in: path description: The portfolio ID of the allocation required: true schema: type: string - name: allocation_id in: path description: The ID of the allocation required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetAllocationResponse' /v1/portfolios/{portfolio_id}/balances: get: tags: - Balances summary: List Portfolio Balances description: List all balances for a specific portfolio. operationId: PrimeRESTAPI_GetPortfolioBalances parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: symbols in: query description: A list of symbols by which to filter the response schema: type: string - name: balance_type in: query description: |- A type by which to filter balances - UNKNOWN_BALANCE_TYPE: nil - TRADING_BALANCES: Trading balances - VAULT_BALANCES: Vault balances - TOTAL_BALANCES: Total balances (The sum of vault and trading + prime custody) - PRIME_CUSTODY_BALANCES: Prime custody balances - UNIFIED_TOTAL_BALANCES: Unified total balance across networks and wallet types (vault + trading + prime custody) schema: type: string enum: - TRADING_BALANCES - VAULT_BALANCES - TOTAL_BALANCES - PRIME_CUSTODY_BALANCES - UNIFIED_TOTAL_BALANCES responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioBalancesResponse' /v1/portfolios/{portfolio_id}/buying_power: get: tags: - Financing summary: Get Portfolio Buying Power description: "Returns the size of a buy trade that can be performed based on\ \ existing holdings and available credit. The result will differ for different\ \ assets due to asset specific credit configurations and caps. Note that this\ \ result is changing based on asset price fluctuations, so may be rejected\ \ when submitted." operationId: PrimeRESTAPI_GetBuyingPower parameters: - name: portfolio_id in: path description: The unique ID of the portfolio required: true schema: type: string - name: base_currency in: query description: The symbol for the base currency required: true schema: type: string - name: quote_currency in: query description: The symbol for the quote currency required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetBuyingPowerResponse' /v1/portfolios/{portfolio_id}/candles: get: tags: - Products summary: Get Public Product Candles (Beta) description: "Get rates for a single product by product ID, grouped in buckets.\ \ This feature is in beta please reach out to your Coinbase Prime account\ \ manager for more information." operationId: PrimeRESTAPI_GetCandles parameters: - name: portfolio_id in: path description: The portfolio id requesting market data. required: true schema: type: string - name: product_id in: query description: The trading pair. required: true schema: type: string - name: start_time in: query description: Timestamp for starting range of aggregations required: true schema: type: string format: date-time - name: end_time in: query description: Timestamp for ending range of aggregations required: true schema: type: string format: date-time - name: granularity in: query description: The timeframe each candle represents. required: true schema: type: string enum: - ONE_MINUTE - FIVE_MINUTES - FIFTEEN_MINUTES - ONE_HOUR - SIX_HOURS - ONE_DAY - THIRTY_MINUTES - TWO_HOURS - FOUR_HOURS responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetCandlesResponse' /v1/portfolios/{portfolio_id}/commission: get: tags: - Commission summary: Get Portfolio Commission description: Retrieve commission associated with a given portfolio. operationId: PrimeRESTAPI_GetPortfolioCommission parameters: - name: portfolio_id in: path required: true schema: type: string - name: product_id in: query description: Specific trading pair to check commission (e.g BTC-USD) schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioCommissionResponse' /v1/portfolios/{portfolio_id}/counterparty: get: tags: - Advanced Transfer summary: Get Portfolio Counterparty ID description: Retrieve the counterparty ID for a given portfolio. operationId: PrimeRESTAPI_GetPortfolioCounterpartyID parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioCounterpartyIDResponse' /v1/portfolios/{portfolio_id}/credit: get: tags: - Financing summary: Get Portfolio Credit Information description: Retrieve a portfolio's post-trade credit information. operationId: PrimeRESTAPI_GetPostTradeCredit parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPostTradeCreditResponse' /v1/portfolios/{portfolio_id}/fills: get: tags: - Orders summary: List Portfolio Fills description: "Retrieve fills on a given portfolio. This endpoint requires a\ \ start_date, and returns a payload with a default limit of 100 if not specified\ \ by the user. The maximum allowed limit is 3000." operationId: PrimeRESTAPI_GetPortfolioFills parameters: - name: portfolio_id in: path description: The portfolio ID associated with the order required: true schema: type: string - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: start_date in: query description: A start date for the fills to be queried from required: true schema: type: string format: date-time - name: end_date in: query description: An end date for the fills to be queried until schema: type: string format: date-time - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioFillsResponse' /v1/portfolios/{portfolio_id}/locates: get: tags: - Financing summary: List Existing Locates description: List locates for the portfolio operationId: PrimeRESTAPI_GetExistingLocates parameters: - name: portfolio_id in: path description: The unique ID of the portfolio required: true schema: type: string - name: locate_ids in: query description: The IDs of specific locates to filter for style: form explode: true schema: type: array items: type: string - name: conversion_date in: query description: "Deprecated: Use locate_date instead" schema: type: string - name: locate_date in: query description: The date of the locates in YYYY-MM-DD format schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetExistingLocatesResponse' post: tags: - Financing summary: Create New Locates description: Create a new locate operationId: PrimeRESTAPI_CreateNewLocates parameters: - name: portfolio_id in: path description: The unique ID of the portfolio required: true schema: type: string requestBody: content: application/json: schema: required: - amount - symbol type: object properties: symbol: type: string description: Currency symbol example: BTC amount: type: string description: Locate Amount example: "100" conversion_date: type: string description: "Deprecated: Use locate_date instead" example: 2023-11-01 locate_date: type: string description: The target date of the locate (YYYY-MM-DD) example: 2023-11-01 required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateNewLocatesResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/margin_conversions: get: tags: - Financing summary: List Margin Conversions description: "Lists conversions and short collateral requirement between specified\ \ date range. This endpoint is deprecated and will be removed in the future.\ \ Use /v1/entities/{entity_id}/margin_summaries instead." operationId: PrimeRESTAPI_GetMarginConversions parameters: - name: portfolio_id in: path description: The unique ID of the portfolio required: true schema: type: string - name: start_date in: query description: The start date of the range to query for in RFC3339 format schema: type: string - name: end_date in: query description: The end date of the range to query for in RFC3339 format schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetMarginConversionsResponse' /v1/portfolios/{portfolio_id}/onchain_address_group: put: tags: - Onchain Address Book summary: Update Onchain Address Book Entry description: Updates an entry to the portfolio's onchain address groups. operationId: PrimeRESTAPI_UpdateOnchainAddressGroup parameters: - name: portfolio_id in: path required: true schema: type: string requestBody: content: application/json: schema: title: ChangeOnchainAddressGroupRequest is a request to create or update a new onchain address group required: - address_group type: object properties: address_group: $ref: '#/components/schemas/coinbase.public_rest_api.AddressGroup' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ActivityCreationResponse' x-codegen-request-body-name: body post: tags: - Onchain Address Book summary: Create Onchain Address Book Entry description: Creates an entry to the portfolio's onchain address groups. operationId: PrimeRESTAPI_CreateOnchainAddressGroup parameters: - name: portfolio_id in: path required: true schema: type: string requestBody: content: application/json: schema: title: ChangeOnchainAddressGroupRequest is a request to create or update a new onchain address group required: - address_group type: object properties: address_group: $ref: '#/components/schemas/coinbase.public_rest_api.AddressGroup' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ActivityCreationResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/onchain_address_group/{address_group_id}: delete: tags: - Onchain Address Book summary: Delete Onchain Address Group description: Deletes an entry in the portfolio's onchain address groups. operationId: PrimeRESTAPI_DeleteOnchainAddressGroup parameters: - name: portfolio_id in: path required: true schema: type: string - name: address_group_id in: path required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ActivityCreationResponse' /v1/portfolios/{portfolio_id}/onchain_address_groups: get: tags: - Onchain Address Book summary: List Onchain Address Groups description: Lists all onchain address groups for a given portfolio ID operationId: PrimeRESTAPI_ListOnchainAddressGroups parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListOnchainAddressGroupsResponse' /v1/portfolios/{portfolio_id}/open_orders: get: tags: - Orders summary: List Open Orders description: "List all open orders.

**Caution:** The maximum number\ \ of orders returned is 5000. If a client has more than 5000 open orders,\ \ an error is returned prompting the user to use Websocket API, or FIX API\ \ to stream open orders." operationId: PrimeRESTAPI_GetOpenOrders parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string - name: product_ids in: query description: List of products by which to filter the response style: form explode: true schema: type: array items: type: string - name: order_type in: query description: |- An order type by which to filter the response - UNKNOWN_ORDER_TYPE: nil value - MARKET: A [market order](https://en.wikipedia.org/wiki/Order_(exchange)#Market_order) - LIMIT: A [limit order](https://en.wikipedia.org/wiki/Order_(exchange)#Limit_order) - TWAP: A [time-weighted average price order](https://en.wikipedia.org/wiki/Time-weighted_average_price) - BLOCK: A [block trade](https://en.wikipedia.org/wiki/Block_trade) - VWAP: A [volume-weighted average price order](https://en.wikipedia.org/wiki/Volume-weighted_average_price) - STOP_LIMIT: A [conditional order combined of stop order and limit order](https://en.wikipedia.org/wiki/Order_(exchange)#Stop-limit_order) - RFQ: A [request for quote](https://en.wikipedia.org/wiki/Request_for_quote) - PEG: A pegged order that dynamically adjust based on market conditions while maintaining execution discretion and avoiding adverse selection schema: type: string enum: - MARKET - LIMIT - TWAP - BLOCK - VWAP - STOP_LIMIT - RFQ - PEG - name: cursor in: query description: "**Deprecated** - this endpoint always returns one page with\ \ at most 1000 orders. If you need to retrieve more than 1000 orders, use\ \ the WebSocket API instead." schema: type: string - name: limit in: query description: "**Deprecated** - the limit for this endpoint is always 1000.\ \ If you need to retrieve more than 1000 orders, use the WebSocket API instead." schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC - name: start_date in: query description: A start date for the orders to be queried from schema: type: string format: date-time - name: order_side in: query description: |- An order side to filter on. - UNKNOWN_ORDER_SIDE: nil value - BUY: Buy order - SELL: Sell order schema: type: string enum: - BUY - SELL - name: end_date in: query description: An end date for the orders to be queried from schema: type: string format: date-time responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetOpenOrdersResponse' /v1/portfolios/{portfolio_id}/order: post: tags: - Orders summary: Create Order description: Create an order. operationId: PrimeRESTAPI_CreateOrder parameters: - name: portfolio_id in: path description: The ID of the portfolio that owns the order required: true schema: type: string requestBody: content: application/json: schema: required: - client_order_id - product_id - side - type type: object properties: product_id: title: The ID of the product being traded for the order (e.g. `BTC-USD`) type: string side: $ref: '#/components/schemas/coinbase.public_rest_api.OrderSide' client_order_id: title: A client-generated order ID used for reference purposes type: string type: $ref: '#/components/schemas/coinbase.public_rest_api.OrderType' base_quantity: title: Order size in base asset units (either `base_quantity` or `quote_value` is required) type: string quote_value: title: "Order size in quote asset units, i.e. the amount the user\ \ wants to spend (when buying) or receive (when selling); the\ \ quantity in base units will be determined based on the market\ \ liquidity and indicated `quote_value` (either `base_quantity`\ \ or `quote_value` is required)" type: string limit_price: title: "The limit price (required for TWAP, VWAP, LIMIT, and STOP_LIMIT\ \ orders)" type: string start_time: title: The start time of the order in UTC (TWAP only) type: string format: date-time expiry_time: title: "The expiry time of the order in UTC (TWAP, VWAP, LIMIT,\ \ and STOP_LIMIT GTD only)" type: string format: date-time time_in_force: $ref: '#/components/schemas/coinbase.public_rest_api.TimeInForceType' stp_id: title: An optional self trade prevention id (in the form of a UUID). The value is only honored for certain clients who are permitted to specify a custom self trade prevention id type: string display_quote_size: type: string description: Optionally specify a display size. This is the maximum order size that will show up on venue order books. Specifying a value here effectively makes a LIMIT order into an "iceberg" style order. This property only applies to LIMIT orders and will be ignored for other order types. display_base_size: type: string is_raise_exact: type: boolean historical_pov: title: Historical percentage of volume type: string stop_price: title: Specifies the stop price at which the order activates. The order is activated if the last trade price on Coinbase Exchange crosses the stop price specified on the order type: string settl_currency: title: The currency in which the settlement will be made type: string post_only: type: boolean description: "Post-only flag - when true, the order will only be\ \ posted to the order book and not immediately matched. Only applicable\ \ to LIMIT orders with GTC or GTD time in force." peg_offset_type: $ref: '#/components/schemas/coinbase.public_rest_api.PegOffsetType' offset: title: Offset value for PEG orders. 0 means peg to BBO. Only non-negative values are allowed (PEG orders only) type: string wig_level: title: "WIG (Would if Good) level - the best price a pegged order\ \ would be placed on venues, opposite to limit_price (PEG orders\ \ only)" type: string description: "next: 23" required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateOrderResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/order_preview: post: tags: - Orders summary: Get Order Preview description: Retrieve an order preview. operationId: PrimeRESTAPI_OrderPreview parameters: - name: portfolio_id in: path description: The ID of the portfolio that owns the order required: true schema: type: string requestBody: content: application/json: schema: required: - product_id - side - type type: object properties: product_id: title: The ID of the product being traded for the order (e.g. `BTC-USD`) type: string side: $ref: '#/components/schemas/coinbase.public_rest_api.OrderSide' type: $ref: '#/components/schemas/coinbase.public_rest_api.OrderType' base_quantity: title: Order size in base asset units (either `base_quantity` or `quote_value` is required) type: string quote_value: title: "Order size in quote asset units, i.e. the amount the user\ \ wants to spend (when buying) or receive (when selling); the\ \ quantity in base units will be determined based on the market\ \ liquidity and indicated `quote_value` (either `base_quantity`\ \ or `quote_value` is required)" type: string limit_price: title: "The limit price (required for TWAP, VWAP, LIMIT and STOP_LIMIT\ \ orders)" type: string start_time: title: "The start time of the order in UTC (TWAP, VWAP only)" type: string format: date-time expiry_time: title: "The expiry time of the order in UTC (TWAP, VWAP, LIMIT and\ \ STOP_LIMIT GTD only)" type: string format: date-time time_in_force: $ref: '#/components/schemas/coinbase.public_rest_api.TimeInForceType' is_raise_exact: title: Raise Exact order flag type: boolean historical_pov: title: Historical percentage of volume type: string stop_price: title: Specifies the stop price at which the order activates. The order is activated if the last trade price on Coinbase Exchange crosses the stop price specified on the order type: string settl_currency: title: The currency in which the settlement will be made type: string postOnly: type: boolean description: Specifies whether the order is treated as a post only order. display_quote_size: type: string description: The maximum order size that will show up on venue order books (in quote currency). example: "100.50" display_base_size: type: string description: The maximum order size that will show up on venue order books (in base currency). example: "10.5" peg_offset_type: $ref: '#/components/schemas/coinbase.public_rest_api.PegOffsetType' offset: title: Offset value for PEG orders. 0 means peg to BBO. Only non-negative values are allowed (PEG orders only) type: string wig_level: title: "WIG (Would if Good) level - the best price a pegged order\ \ would be placed on venues, opposite to limit_price (PEG orders\ \ only)" type: string description: "next: 21" required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.PostOrderPreviewResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/orders: get: tags: - Orders summary: List Portfolio Orders description: "List historical orders for a given portfolio. This endpoint returns\ \ a payload with a default limit of 100 if not specified by the user. The\ \ maximum allowed limit is 3000.

**Caution:** Currently, you cannot\ \ query open orders with this endpoint: use List Open Orders if you have less\ \ than 1000 open orders, otherwise use Websocket API, or FIX API to stream\ \ open orders." operationId: PrimeRESTAPI_GetOrders parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string - name: order_statuses in: query description: |- List of statuses by which to filter the response - UNKNOWN_ORDER_STATUS: nil value - OPEN: The order is open but unfilled - FILLED: The order was filled - CANCELLED: The order was cancelled - EXPIRED: The order has expired - FAILED: Order submission failed - PENDING: The order has been sent but is not yet confirmed style: form explode: true schema: type: array items: type: string enum: - OPEN - FILLED - CANCELLED - EXPIRED - FAILED - PENDING - name: product_ids in: query description: List of products by which to filter the response style: form explode: true schema: type: array items: type: string - name: order_type in: query description: |- Order type by which to filter the response - UNKNOWN_ORDER_TYPE: nil value - MARKET: A [market order](https://en.wikipedia.org/wiki/Order_(exchange)#Market_order) - LIMIT: A [limit order](https://en.wikipedia.org/wiki/Order_(exchange)#Limit_order) - TWAP: A [time-weighted average price order](https://en.wikipedia.org/wiki/Time-weighted_average_price) - BLOCK: A [block trade](https://en.wikipedia.org/wiki/Block_trade) - VWAP: A [volume-weighted average price order](https://en.wikipedia.org/wiki/Volume-weighted_average_price) - STOP_LIMIT: A [conditional order combined of stop order and limit order](https://en.wikipedia.org/wiki/Order_(exchange)#Stop-limit_order) - RFQ: A [request for quote](https://en.wikipedia.org/wiki/Request_for_quote) - PEG: A pegged order that dynamically adjust based on market conditions while maintaining execution discretion and avoiding adverse selection schema: type: string enum: - MARKET - LIMIT - TWAP - BLOCK - VWAP - STOP_LIMIT - RFQ - PEG - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC - name: order_side in: query description: |- An order side to filter on. - UNKNOWN_ORDER_SIDE: nil value - BUY: Buy order - SELL: Sell order schema: type: string enum: - BUY - SELL - name: start_date in: query description: A start date for the orders to be queried from schema: type: string format: date-time - name: end_date in: query description: An end date for the orders to be queried from schema: type: string format: date-time responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetOrdersResponse' /v1/portfolios/{portfolio_id}/orders/{order_id}: get: tags: - Orders summary: Get Order by Order ID description: Retrieve an order by order ID. operationId: PrimeRESTAPI_GetOrder parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string - name: order_id in: path description: Order ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetOrderResponse' /v1/portfolios/{portfolio_id}/orders/{order_id}/cancel: post: tags: - Orders summary: Cancel Order description: Cancel an order. (Filled orders cannot be canceled.) operationId: PrimeRESTAPI_CancelOrder parameters: - name: portfolio_id in: path description: The ID of the portfolio under which the order was placed required: true schema: type: string - name: order_id in: path description: The order ID generated by Coinbase upon order submission required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CancelOrderResponse' /v1/portfolios/{portfolio_id}/orders/{order_id}/edit: put: tags: - Orders summary: Edit Order (Beta) description: Edit an open order. This feature is in beta please reach out to your Coinbase Prime account manager for more information. operationId: PrimeRESTAPI_EditOrder parameters: - name: portfolio_id in: path description: The ID of the portfolio that owns the order required: true schema: type: string - name: order_id in: path description: The ID of the order being edited required: true schema: type: string requestBody: content: application/json: schema: required: - client_order_id - orig_client_order_id type: object properties: product_id: type: string description: "Deprecated: The product ID of the order being edited" orig_client_order_id: type: string description: The client order ID of the order being edited client_order_id: type: string description: The updated version of the client order ID base_quantity: type: string description: Order size in base asset units (either `base_quantity` or `quote_value` is required) quote_value: type: string description: "Order size in quote asset units, i.e. the amount the\ \ user wants to spend (when buying) or receive (when selling);\ \ the quantity in base units will be determined based on the market\ \ liquidity and indicated `quote_value` (either `base_quantity`\ \ or `quote_value` is required)" limit_price: type: string description: "The limit price (required for TWAP, VWAP, LIMIT, and\ \ STOP_LIMIT orders)" expiry_time: type: string description: "The expiry time of the order in UTC (TWAP, VWAP, LIMIT,\ \ and STOP_LIMIT GTD only)" format: date-time display_quote_size: type: string description: The maximum order size that will show up on venue order books. Specifying a value here effectively makes a LIMIT order into an "iceberg" style order. display_base_size: type: string description: The maximum order size that will show up on venue order books. Specifying a value here effectively makes a LIMIT order into an "iceberg" style order. stop_price: type: string description: Specifies the stop price at which the order activates. The order is activated if the last trade price on Coinbase Exchange crosses the stop price specified on the order offset: type: string description: New peg offset value for PEG orders. 0 means peg to BBO. Only non-negative values are allowed. The order's peg_offset_type is immutable and is reused server-side to interpret this value (PEG orders only) wig_level: type: string description: "New WIG (Would if Good) level for PEG orders - the\ \ best price a pegged order would be placed on venues, opposite\ \ to limit_price. Cannot be added or removed post-placement (PEG\ \ orders only)" required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.EditOrderResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/orders/{order_id}/edit_history: get: tags: - Orders summary: List Order Edit History description: List edit history for a specific order operationId: PrimeRESTAPI_GetOrderEditHistory parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: order_id in: path description: The order ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetOrderEditHistoryResponse' /v1/portfolios/{portfolio_id}/orders/{order_id}/fills: get: tags: - Orders summary: List Order Fills description: Retrieve fills on a given order. This endpoint returns a payload with a default limit of 100 if not specified by the user. The maximum allowed limit is 3000. operationId: PrimeRESTAPI_GetOrderFills parameters: - name: portfolio_id in: path description: The portfolio ID associated with the order required: true schema: type: string - name: order_id in: path description: The order ID generated by Coinbase required: true schema: type: string - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetOrderFillsResponse' /v1/portfolios/{portfolio_id}/products: get: tags: - Products summary: List Portfolio Products description: List tradable products for a given portfolio. operationId: PrimeRESTAPI_GetPortfolioProducts parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC - name: product_type in: query description: |- Filter by product type (SPOT, FUTURE). If unset, returns all types available for your portfolio. Futures products require additional entitlements. - UNKNOWN_PRODUCT_TYPE: Unknown product type - SPOT: Spot product - FUTURE: Future product schema: type: string enum: - SPOT - FUTURE - name: contract_expiry_type in: query description: |- Filter by contract expiry type (EXPIRING or PERPETUAL). Only applicable when product_type = FUTURE. If unset, returns all futures kinds. - CONTRACT_EXPIRY_TYPE_UNSPECIFIED: Unspecified contract expiry type - CONTRACT_EXPIRY_TYPE_EXPIRING: Expiring futures contract - CONTRACT_EXPIRY_TYPE_PERPETUAL: Perpetual futures contract (no expiry) schema: type: string default: CONTRACT_EXPIRY_TYPE_UNSPECIFIED enum: - CONTRACT_EXPIRY_TYPE_UNSPECIFIED - CONTRACT_EXPIRY_TYPE_EXPIRING - CONTRACT_EXPIRY_TYPE_PERPETUAL - name: expiring_contract_status in: query description: |- Filter by expiry status for expiring futures. If unset, returns all expiring futures. - EXPIRING_CONTRACT_STATUS_UNKNOWN: Unknown/unset — returns all expiring contracts (backward compatible default) - EXPIRING_CONTRACT_STATUS_UNEXPIRED: Only unexpired contracts (contract_expiry is in the future) - EXPIRING_CONTRACT_STATUS_EXPIRED: Only expired contracts (contract_expiry is in the past) - EXPIRING_CONTRACT_STATUS_ALL: All contracts regardless of expiry status schema: type: string enum: - EXPIRING_CONTRACT_STATUS_UNEXPIRED - EXPIRING_CONTRACT_STATUS_EXPIRED - EXPIRING_CONTRACT_STATUS_ALL responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioProductsResponse' /v1/portfolios/{portfolio_id}/rfq: post: tags: - Orders summary: Create Quote Request description: |- A Quote Request is the start of the RFQ process. Coinbase Prime sends a Quote Request to Liquidity Providers (LPs) on behalf of a customer looking to participate in an RFQ trade. Always required: portfolio_id, product_id, side, client_quote_id, and limit_price. One of either base_quantity or quote_value is always required. operationId: PrimeRESTAPI_CreateQuoteRequest parameters: - name: portfolio_id in: path description: The ID of the portfolio that owns the order required: true schema: type: string requestBody: content: application/json: schema: title: RFQ required: - client_quote_id - limit_price - product_id - side type: object properties: product_id: title: The ID of the product being traded for the order (e.g. `BTC-USD`) type: string side: $ref: '#/components/schemas/coinbase.public_rest_api.OrderSide' client_quote_id: title: Based off of Order type: string description: "A client-generated order ID used for reference purposes\ \ (note: order will be rejected if this ID is not unique among\ \ all currently active orders)" example: f69a20b1-4ac4-420e-90b5-814a12565bfa base_quantity: title: Order size in base asset units (either `base_quantity` or `quote_value` is required) type: string quote_value: title: "Order size in quote asset units, i.e. the amount the user\ \ wants to spend (when buying) or receive (when selling); the\ \ quantity in base units will be determined based on the market\ \ liquidity and indicated `quote_value` (either `base_quantity`\ \ or `quote_value` is required)" type: string limit_price: title: The limit price type: string settl_currency: title: The currency in which the settlement will be made type: string quote_duration_ms: type: string description: Optional quote timeout in milliseconds. Defaults to 3000 ms (3 seconds) if not specified. Maximum allowed value is 30000 ms (30 seconds); requests with a larger value are rejected. Mirrors FIX tag 8090 (QuoteRequestGoodForMs). format: int64 example: "5000" description: based off PostOrderPreviewRequest required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.QuoteResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/staking/initiate: post: tags: - Staking summary: Request to stake currency in a portfolio description: "Creates an execution request to stake funds across a portfolio.\ \ This will stake funds in one or more wallets in the portfolio, with a total\ \ bondable balance up to the requested stake amount." operationId: PrimeRESTAPI_PortfolioStakingInitiate parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string requestBody: content: application/json: schema: required: - amount - currency_symbol - idempotency_key type: object properties: idempotency_key: type: string description: The client generated idempotency key (uuid required) for requested execution. Subsequent requests using the same key will not create new transactions. currency_symbol: type: string description: The currency symbol to stake amount: type: string description: The quantity of the chosen currency to stake metadata: $ref: '#/components/schemas/coinbase.public_rest_api.PortfolioStakingMetadata' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.PortfolioStakingInitiateResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/staking/transaction-validators/query: post: tags: - Staking summary: List Transaction Validators description: "List ETH 0x02 validators associated with wallet-level stake transactions\ \ for a given portfolio. It will not return data for unstake transactions,\ \ portfolio stake transactions, transactions which staked different currencies,\ \ or which staked to Ethereum 0x01 validators." operationId: PrimeRESTAPI_ListTransactionValidators parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string requestBody: content: application/json: schema: required: - transaction_ids type: object properties: transaction_ids: type: array description: List of transaction IDs to filter validators by. Maximum of 100 transaction IDs allowed per request. items: type: string cursor: type: string description: Cursor for pagination limit: type: integer description: "Maximum number of transaction-validator associations\ \ to return per page. Default is 100, maximum is 1000." format: int32 sort_direction: $ref: '#/components/schemas/coinbase.public_rest_api.SortDirection' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListTransactionValidatorsResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/staking/unstake: post: tags: - Staking summary: Request to unstake currency across a portfolio description: "Creates an execution request to unstake funds across a portfolio.\ \ This will unstake funds in one or more wallets in the portfolio, with a\ \ total bonded balance up to the requested unstake amount." operationId: PrimeRESTAPI_PortfolioStakingUnstake parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string requestBody: content: application/json: schema: required: - currency_symbol - idempotency_key type: object properties: idempotency_key: type: string description: The client generated idempotency key (uuid required) for requested execution. Subsequent requests using the same key will not create new transactions. currency_symbol: type: string description: The currency symbol to unstake amount: type: string description: The quantity of the chosen currency to unstake metadata: $ref: '#/components/schemas/coinbase.public_rest_api.PortfolioStakingMetadata' validator_provider: $ref: '#/components/schemas/coinbase.public_rest_api.ValidatorProvider' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.PortfolioStakingUnstakeResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/transactions: get: tags: - Transactions summary: List Portfolio Transactions description: List transactions for a given portfolio. operationId: PrimeRESTAPI_GetPortfolioTransactions parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: symbols in: query description: A case insensitive list of symbols by which to filter the response schema: type: string - name: types in: query description: |- The transaction types by which to filter the response - TRANSACTION_TYPE_UNKNOWN: An unknown transaction type - DEPOSIT: A fiat or crypto deposit - WITHDRAWAL: A fiat or crypto withdrawal - INTERNAL_DEPOSIT: An internal fiat or crypto deposit - INTERNAL_WITHDRAWAL: An internal fiat or crypto withdrawal - SWEEP_DEPOSIT: Internal automated deposit to a cold address from a restored address - SWEEP_WITHDRAWAL: Internal automated withdrawal from a restored address to a cold address - PROXY_DEPOSIT: On-chain deposit of funds into proxy contract from cold address - PROXY_WITHDRAWAL: On-chain withdrawal of funds from proxy contract to cold address - BILLING_WITHDRAWAL: Coinbase Prime automated invoice settlement payment - REWARD: Reward payment to an associated address for a staked asset - COINBASE_REFUND: Coinbase Prime refund for the leftover amount for a CPFP (child pays for parent) transaction - TRANSACTION_TYPE_OTHER: An OTHER type of transaction - WITHDRAWAL_ADJUSTMENT: A manual adjustment withdrawal transaction - DEPOSIT_ADJUSTMENT: A manual adjustment deposit transaction - KEY_REGISTRATION: An on-chain registration for an address - DELEGATION: An on-chain delegation transaction - UNDELEGATION: An on-chain undelegation transaction - RESTAKE: On-chain restaking transaction - COMPLETE_UNBONDING: On-chain unbonding event transaction - WITHDRAW_UNBONDED: On-chain event indicating unbonding period is over - STAKE_ACCOUNT_CREATE: On-chain transaction to begin staking from an address - CHANGE_VALIDATOR: On-chain transaction alter validator - STAKE: On-chain transaction to begin staking in Cryptocurrency network - UNSTAKE: On-chain transaction to stop staking in Cryptocurrency network - REMOVE_AUTHORIZED_PARTY: On-chain transaction to remove a party from a multi-signature wallet - STAKE_AUTHORIZE_WITH_SEED: On-chain transaction to begin staking from a seed account - SLASH: On-chain transaction indicating a slash event has occurred - COINBASE_DEPOSIT: On-chain transaction deposit for the purpose of transaction operations - CONVERSION: Internal conversion between two assets - CLAIM_REWARDS: On-chain transaction to claim rewards from Vote Account - VOTE_AUTHORIZE: On-chain transaction to transfer the reward claiming permission to other pubkey - WEB3_TRANSACTION: On-chain transaction initiated with Prime Onchain Wallet Deprecated: Use ONCHAIN_TRANSACTION instead - ONCHAIN_TRANSACTION: On-chain transaction initiated with Prime Onchain Wallet - PORTFOLIO_STAKE: Portfolio-level staking operation - PORTFOLIO_UNSTAKE: Portfolio-level unstaking operation style: form explode: true schema: type: array items: type: string enum: - DEPOSIT - WITHDRAWAL - INTERNAL_DEPOSIT - INTERNAL_WITHDRAWAL - SWEEP_DEPOSIT - SWEEP_WITHDRAWAL - PROXY_DEPOSIT - PROXY_WITHDRAWAL - BILLING_WITHDRAWAL - REWARD - COINBASE_REFUND - TRANSACTION_TYPE_OTHER - WITHDRAWAL_ADJUSTMENT - DEPOSIT_ADJUSTMENT - KEY_REGISTRATION - DELEGATION - UNDELEGATION - RESTAKE - COMPLETE_UNBONDING - WITHDRAW_UNBONDED - STAKE_ACCOUNT_CREATE - CHANGE_VALIDATOR - STAKE - UNSTAKE - REMOVE_AUTHORIZED_PARTY - STAKE_AUTHORIZE_WITH_SEED - SLASH - COINBASE_DEPOSIT - CONVERSION - CLAIM_REWARDS - VOTE_AUTHORIZE - WEB3_TRANSACTION - ONCHAIN_TRANSACTION - PORTFOLIO_STAKE - PORTFOLIO_UNSTAKE - name: start_time in: query description: "UTC timestamp from which to filter the response (inclusive,\ \ ISO-8601 format)" schema: type: string format: date-time - name: end_time in: query description: "UTC timestamp until which to filter the response (exclusive,\ \ ISO-8601 format)" schema: type: string format: date-time - name: cursor in: query description: Id to retrieve additional results strictly after. schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Page sorting direction schema: type: string default: DESC enum: - DESC - ASC - name: get_network_unified_transactions in: query description: Flag to request retrieval of all transactions across all networks for a given symbol schema: type: boolean - name: travel_rule_status in: query description: (Alpha) Filter for status of returned transactions' travel rule submissions - an inclusive OR filter style: form explode: true schema: type: array items: type: string enum: - TRAVEL_RULE_STATUS_UNSPECIFIED - TRAVEL_RULE_STATUS_PENDING - TRAVEL_RULE_STATUS_SUBMITTED responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioTransactionsResponse' /v1/portfolios/{portfolio_id}/transactions/{transaction_id}: get: tags: - Transactions summary: Get Transaction by Transaction ID description: Retrieve a specific transaction by its transaction ID. operationId: PrimeRESTAPI_GetTransaction parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: transaction_id in: path description: The transaction ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetTransactionResponse' /v1/portfolios/{portfolio_id}/transactions/{transaction_id}/travel_rule: get: tags: - Travel Rule summary: Get Transaction Travel Rule Data description: (Beta) Get fulfilled travel rule data for a transaction. operationId: PrimeRESTAPI_GetTransactionTravelRuleData parameters: - name: portfolio_id in: path description: The portfolio ID that owns the transaction required: true schema: type: string - name: transaction_id in: path description: The transaction ID to look up travel rule data for required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetTransactionTravelRuleDataResponse' /v1/portfolios/{portfolio_id}/transactions/{transaction_id}/travel_rule/deposit: post: tags: - Travel Rule summary: Submit Deposit Travel Rule Data description: Submit travel rule data for an existing deposit transaction. operationId: PrimeRESTAPI_SubmitDepositTravelRuleData parameters: - name: portfolio_id in: path description: The portfolio ID that owns the transaction required: true schema: type: string - name: transaction_id in: path description: The transaction ID associated with the entry required: true schema: type: string requestBody: content: application/json: schema: title: Request to submit travel rule data for an existing deposit transaction type: object properties: originator: $ref: '#/components/schemas/coinbase.public_rest_api.TravelRuleParty' beneficiary: $ref: '#/components/schemas/coinbase.public_rest_api.TravelRuleParty' is_self: title: |- True if user owns the counterparty address (self-transfer) If false, beneficiary is required type: boolean opt_out_of_ownership_verification: title: True to skip wallet ownership verification type: boolean required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.SubmitDepositTravelRuleDataResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/users: get: tags: - Users summary: List Portfolio Users description: List all users associated with a given portfolio. operationId: PrimeRESTAPI_GetPortfolioUsers parameters: - name: portfolio_id in: path description: The portfolio ID. required: true schema: type: string - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: string - name: limit in: query description: Number of items to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetPortfolioUsersResponse' /v1/portfolios/{portfolio_id}/wallets: get: tags: - Wallets summary: List Portfolio Wallets description: List all wallets associated with a given portfolio. operationId: PrimeRESTAPI_GetWallets parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: type in: query description: |- The wallet type - VAULT: A crypto vault - TRADING: A trading wallet - WALLET_TYPE_OTHER: Other wallet types (like consumer, etc) - QC: A QC Wallet - ONCHAIN: An Onchain wallet required: true schema: type: string enum: - VAULT - TRADING - WALLET_TYPE_OTHER - QC - ONCHAIN - name: cursor in: query description: Cursor used for pagination (last consumed record) schema: type: string - name: limit in: query description: Number of wallets to retrieve schema: type: integer format: int32 - name: sort_direction in: query description: Sorting order schema: type: string default: DESC enum: - DESC - ASC - name: symbols in: query description: The wallet symbol style: form explode: true schema: type: array items: type: string - name: get_network_unified_wallets in: query description: Flag to request retrieval of all wallets across all networks for a given symbol schema: type: boolean responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetWalletsResponse' post: tags: - Wallets summary: Create Wallet description: "Create a wallet. Note: The first ONCHAIN wallet for each network\ \ family must be created through the Prime UI." operationId: PrimeRESTAPI_CreateWallet parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string requestBody: content: application/json: schema: required: - name - symbol type: object properties: name: title: The name of the wallet type: string symbol: title: The asset stored in the wallet. Should not be specified when wallet_type is ONCHAIN type: string wallet_type: $ref: '#/components/schemas/coinbase.public_rest_api.WalletType' idempotency_key: title: idem type: string network_family: $ref: '#/components/schemas/coinbase.public_rest_api.NetworkFamily' network: $ref: '#/components/schemas/coinbase.public_rest_api.Network' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateWalletResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/wallets/{wallet_id}: get: tags: - Wallets summary: Get Wallet by Wallet ID description: Retrieve a specific wallet by Wallet ID. operationId: PrimeRESTAPI_GetWallet parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string - name: wallet_id in: path description: Wallet ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetWalletResponse' /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/addresses: get: tags: - Wallets summary: List Wallet Addresses description: Returns all deposit addresses associated with a wallet operationId: PrimeRESTAPI_ListWalletAddresses parameters: - name: portfolio_id in: path description: The portfolio ID associated with the wallet required: true schema: type: string - name: wallet_id in: path description: The wallet ID for which to retrieve all deposit addresses required: true schema: type: string - name: network_id in: query description: "The blockchain network name and type, provide an empty network\ \ to retrieve addresses across all networks for this wallet" schema: type: string - name: cursor in: query description: Cursor to retrieve the next page of results schema: type: string - name: limit in: query description: Maximum number of addresses to return in a single response schema: type: integer format: int32 responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.ListWalletAddressesResponse' post: tags: - Wallets summary: Create Wallet Deposit Address description: Creates a new deposit address for a wallet. Only applicable to wallets that support multiple deposit addresses on a given network operationId: PrimeRESTAPI_CreateWalletDepositAddress parameters: - name: portfolio_id in: path description: The ID of the portfolio that owns the wallet required: true schema: type: string - name: wallet_id in: path description: The wallet ID for which to create the deposit address required: true schema: type: string requestBody: content: application/json: schema: required: - network_id type: object properties: network_id: title: "The network information, ie which network to retrieve the\ \ deposit address for (such as base-mainnet)" type: string description: The network name and type example: ethereum-mainnet required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.BlockchainAddress' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/balance: get: tags: - Balances summary: Get Wallet Balance description: Query balance for a specific wallet. operationId: PrimeRESTAPI_GetWalletBalance parameters: - name: portfolio_id in: path description: Portfolio ID required: true schema: type: string - name: wallet_id in: path description: Wallet ID required: true schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetWalletBalanceResponse' /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/conversion: post: tags: - Transactions summary: Create Conversion description: Perform a conversion between 2 assets. operationId: PrimeRESTAPI_CreateConversion parameters: - name: portfolio_id in: path description: The ID of the portfolio required: true schema: type: string - name: wallet_id in: path description: The wallet ID that the conversion will originate from required: true schema: type: string requestBody: content: application/json: schema: required: - amount - destination - destination_symbol - idempotency_key - source_symbol type: object properties: amount: type: string description: The amount in whole units to convert example: "50.50" destination: type: string description: The UUID of the destination wallet example: e84255eb-2e21-439e-a1d0-f5dd1e1292b9 idempotency_key: type: string description: The idempotency key associated with this conversion example: e84255eb-2e21-439e-a1d0-f5dd1e1292b9 source_symbol: type: string description: The currency symbol to convert from example: USD destination_symbol: type: string description: The currency symbol to convert to example: USDC required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateConversionResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/cross-asset-withdrawals: post: tags: - Transactions summary: Create Cross-Asset Wallet Withdrawal description: "Create a withdrawal where the source asset differs from the destination\ \ asset (e.g. USDC source, USDT-on-TRON destination)." operationId: PrimeRESTAPI_CreateCrossAssetWalletWithdrawal parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: wallet_id in: path description: The source wallet ID (must hold source_currency_symbol) required: true schema: type: string requestBody: content: application/json: schema: required: - blockchain_address - destination_amount - destination_currency_symbol - idempotency_key - source_currency_symbol type: object properties: idempotency_key: type: string description: The idempotency key associated with the withdrawal source_currency_symbol: type: string description: The currency symbol debited from the wallet (e.g. "USDC") destination_currency_symbol: type: string description: The currency symbol delivered to the destination (e.g. "USDT") destination_amount: type: string description: "Exact amount of destination_currency_symbol to deliver,\ \ in whole units. The corresponding source amount debited from\ \ the wallet is computed downstream." blockchain_address: $ref: '#/components/schemas/coinbase.public_rest_api.BlockchainAddress' travel_rule_data: $ref: '#/components/schemas/coinbase.public_rest_api.TravelRuleData' description: |- Create a cross-asset wallet withdrawal: source asset is debited from the wallet and destination asset is delivered to the destination. The source amount is computed downstream based on the use case. The relationship between source and destination assets (bridge, swap, etc.) is an internal implementation detail and is not exposed on the wire. required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateCrossAssetWalletWithdrawalResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/deposit_instructions: get: tags: - Wallets summary: Get Wallet Deposit Instructions description: Retrieve a specific wallet's deposit instructions. operationId: PrimeRESTAPI_GetWalletDepositInstructions parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: wallet_id in: path description: The wallet ID required: true schema: type: string - name: deposit_type in: query description: |- The deposit type - UNKNOWN_WALLET_DEPOSIT_TYPE: nil value - CRYPTO: A cryptocurrency deposit - WIRE: A wire deposit - SEN: DEPRECATED. A Silvergate Exchange Network deposit - SWIFT: A SWIFT deposit - SEPA: A SEPA deposit (Single Euro Payments Area) required: true schema: type: string enum: - CRYPTO - WIRE - SEN - SWIFT - SEPA - name: network.id in: query description: |- The name of the network The network id: base, bitcoin, ethereum, solana etc schema: type: string - name: network.type in: query description: |- The network type The network type: mainnet, testnet, etc schema: type: string responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.GetWalletDepositInstructionsResponse' /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/onchain_transaction: post: tags: - Transactions summary: Create Onchain Transaction description: Create an onchain transaction. operationId: PrimeRESTAPI_CreateOnchainTransaction parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: wallet_id in: path description: The wallet ID required: true schema: type: string requestBody: content: application/json: schema: required: - raw_unsigned_txn type: object properties: raw_unsigned_txn: type: string description: Raw unsigned transaction in Hex format (Supports EVM and Solana) example: |- [EVM Example]: 02f00180830f424085057db95cdf825208942225166893d26f2064a15cc84f5b897591a7e6938642a13798e59d80c0808080 [Solana Example]: 010000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000080010002045bae9ac3406b6ad02953cef2646a07966df84f35c0d754d5cc628d452299fcc606c34c7ae7b6d15777787f4f5217d8f2537e7efecabf3d96c39952ed2144322e00000000000000000000000000000000000000000000000000000000000000000306466fe5211732ffecadba72c39be7bc8ce5bbc5f7126b2c439b3a40000000dc34215f010238fbe5a955301891d29cdc1ea2b1f175e36c01c7cde0126ba58303020200010c02000000364b16000000000003000903102700000000000003000502400d030000 rpc: $ref: '#/components/schemas/coinbase.public_rest_api.RpcConfig' evm_params: $ref: '#/components/schemas/coinbase.public_rest_api.CreateOnchainTransactionRequest.EvmParams' required: true responses: "200": description: A successful response. content: application/json: schema: $ref: '#/components/schemas/coinbase.public_rest_api.CreateOnchainTransactionResponse' x-codegen-request-body-name: body /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/staking/claim_rewards: post: tags: - Staking summary: Claim Wallet Staking Rewards (Alpha) description: Request to claim staking rewards. This feature is only for ETH Pectra (0x02) validators. operationId: PrimeRESTAPI_StakingClaimRewards parameters: - name: portfolio_id in: path description: The portfolio ID required: true schema: type: string - name: wallet_id in: path description: The wallet ID required: true schema: type: string requestBody: content: application/json: schema: required: - idempotency_key type: object properties: idempotency_key: type: string description: The client generated idempotency key for requested execution. Any subsequent requests with the same key will return the original response inputs: $ref: '#/components/schemas/coinbase.public_rest_api.WalletClaimRewardsInputs' description: |- StakingClaimRewardsRequest represents a request to cla
[...]
